unit maintest;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, ComCtrls, Grids, fmDsgn, LibReg, DsgnIntf, ImgList,
  Buttons, RXGrids, BtnPanel, CompPal, ActnList, Menus, DsnEvents, propctrl,
  DBGrids, Mask, DBCtrls, TypInfo, RegMeth;

type
{
   :
 + 1.   ()
 + 2. Align 
 + 3. Size 
 + 4. Tab Order 
 + 5. Creation order 
 + 6. Align 
 + 7. Scale 
 + 8.  .   
 + 9.   TCollection
 + 10.  TPersistent  
   11.  TExtEdit
 + 12.     TTabControl
 + 13.     TPallettePanel
   14.     
   15. Pallette Customize 
   16. Packages 
 + 17.     Design Pack
   18.  
   19. Object TreeView 
 + 20.  TCustomModule
 + 21.  
   22.   ,    
   23.  Lock  
 + 24.      ,    Control
 + 25.   
 + 26.      
 + 27. Component Captions
}

  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Panel1: TPanel;
    StatusBar1: TStatusBar;
    Dsn: TzFormDesigner;
    ImageList1: TImageList;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    Button3: TButton;
    Button4: TButton;
    PalettePanel1: TPalettePanel;
    Memo1: TMemo;
    ActionList1: TActionList;
    MainMenu1: TMainMenu;
    Test11: TMenuItem;
    Test21: TMenuItem;
    Test31: TMenuItem;
    Test41: TMenuItem;
    Test51: TMenuItem;
    DesignerEvents1: TDesignerEvents;
    N43: TMenuItem;
    N41: TMenuItem;
    N1: TMenuItem;
    ExitDesigner1: TMenuItem;
    Button5: TButton;
    Bevel1: TBevel;
    Label1: TLabel;
    actTabSheet: TAction;
    actPanel: TAction;
    actForm: TAction;
    actReport: TAction;
    actDataModule: TAction;
    actNewForm: TAction;
    actRunMode: TAction;
    Image1: TImage;
    actShowReport: TAction;
    actShowNewForm: TAction;
    N42: TMenuItem;
    NewForm1: TMenuItem;
    Button6: TButton;
    DBNavigator1: TDBNavigator;
    PageControl2: TPageControl;
    TabSheet3: TTabSheet;
    TabSheet4: TTabSheet;
    DBImage1: TDBImage;
    DBMemo1: TDBMemo;
    Label2: TLabel;
    DBEdit1: TDBEdit;
    Label3: TLabel;
    DBEdit2: TDBEdit;
    Label4: TLabel;
    DBEdit3: TDBEdit;
    Label5: TLabel;
    DBEdit4: TDBEdit;
    Label6: TLabel;
    DBEdit5: TDBEdit;
    Panel2: TPanel;
    Edit1: TEdit;
    CheckBox1: TCheckBox;
    RadioButton1: TRadioButton;
    ComboBox1: TComboBox;
    Label7: TLabel;
    Panel3: TPanel;
    Button7: TButton;
    Label8: TLabel;
    Label9: TLabel;
    DBGrid1: TDBGrid;
    DBEdit6: TDBEdit;
    Label10: TLabel;
    Label11: TLabel;
    DBEdit7: TDBEdit;
    DBNavigator2: TDBNavigator;
    DBEdit8: TDBEdit;
    DBEdit9: TDBEdit;
    DBEdit10: TDBEdit;
    Label12: TLabel;
    Label13: TLabel;
    Button8: TButton;
    N44: TMenuItem;
    procedure RunDesignerClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    function DesignerEvents1GetGlobalComponents(Sender: IDesigner;
      const List: TList): Boolean;
    procedure DesignerEvents1ActiveDsnChanged(Sender: TObject);
    procedure DesignerEvents1DsnKeyDown(Sender: IDesigner; var Key: Word;
      Shift: TShiftState);
    procedure DesignerEvents1GetWorkspaceOrigin(Sender: TObject;
      var P: TPoint);
    procedure DesignerEvents1KeyPress(Sender: IDesigner; var Key: Char);
    procedure DsnActiveChanged(Sender: TObject);
    procedure actShowReportExecute(Sender: TObject);
    procedure actShowNewFormExecute(Sender: TObject);
    procedure actRunModeExecute(Sender: TObject);
    procedure DsnValidateMethod(Sender: TObject; TypeData: PTypeData;
      ARoot: TObject; MethAddr: Pointer; const MethodName: String;
      var Accept: Boolean);
  private
    NewForm: TForm;
  public
  end;

var
  Form1: TForm1;

implementation

uses AlignPal, Unit1, ObjInsp, cPalWnd, DsnCtrl, Unit2, DsnActions;

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
begin
  AlignPallette := TAlignPallette.Create(Application);
  DsnLoadPackage('dclstd50.bpl');
  DsnLoadPackage('dcldb50.bpl');
  DsnLoadPackage('dclqrt50.bpl');
  DsnLoadPackage('dclbde50.bpl');
  with MethRegister do
   begin
    AddNotifyEvent(RunDesignerClick);
    AddNotifyEvent(FormCreate);
    AddNotifyEvent(DesignerEvents1ActiveDsnChanged);
    AddNotifyEvent(DsnActiveChanged);
    AddNotifyEvent(actShowReportExecute);
    AddNotifyEvent(actShowNewFormExecute);
    AddNotifyEvent(actRunModeExecute);
   end;
end;

procedure TForm1.RunDesignerClick(Sender: TObject);
var p: TPoint;
begin
  Dsn.Active := False;
  case (Sender as TComponent).Tag of
   1: Dsn.ContainerWindow := TabSheet1;
   2: Dsn.ContainerWindow := Panel1;
   3: Dsn.ContainerWindow := Self;
   4: Dsn.Root := QuickReport1;
   5: Dsn.Root := DataModule1;
   6: begin
       if not Assigned(NewForm) then
       begin
         NewForm := TForm.Create(Application);
         NewForm.Name := 'TestNewForm';
         p := DsnManager.GetWorkspaceOrigin;
         NewForm.Left := p.x;
         NewForm.Top := p.y;
       end;
       Dsn.ContainerWindow := NewForm;
      end;
  end;
  Dsn.Active := True;
end;

function TForm1.DesignerEvents1GetGlobalComponents(Sender: IDesigner;
  const List: TList): Boolean;
begin
 Result := True;
 List.Add(DataModule1);
 List.Add(QuickReport1);
end;

procedure TForm1.DesignerEvents1ActiveDsnChanged(Sender: TObject);
begin
  ObjectInspector.Visible := (DsnManager.ActiveDesigner <> nil);
  DsnToolbar.Visible := (DsnManager.ActiveDesigner <> nil);
  if DsnManager.ActiveDesigner = nil then
    AlignPallette.Hide;
end;

procedure TForm1.DesignerEvents1DsnKeyDown(Sender: IDesigner;
  var Key: Word; Shift: TShiftState);
begin
 if DsnManager.ActiveDesigner <> nil then
 case Key of
   VK_F10:    ObjectInspector.Show;
   VK_F9:     DsnToolbar.Show;
 end;
end;

procedure TForm1.DesignerEvents1GetWorkspaceOrigin(Sender: TObject;
  var P: TPoint);
begin
   P := Point(ObjectInspector.Width, DsnToolbar.Height);
end;

procedure TForm1.DesignerEvents1KeyPress(Sender: IDesigner; var Key: Char);
var IL: TInspectorList;
begin
 if (Ord(Key) >= 32) and ObjectInspector.Visible then
  with ObjectInspector do
  begin
   if PageControl1.ActivePage.PageIndex = 0 then IL := IL1 else IL := IL2;
   IL.SetFocus;
   IL.Editor.Perform(WM_CHAR, Ord(Key), 0);
  end;
end;

procedure TForm1.DsnActiveChanged(Sender: TObject);
begin
  actTabSheet.Enabled := not Dsn.Active;
  actPanel.Enabled := not Dsn.Active;
  actForm.Enabled := not Dsn.Active;
  actReport.Enabled := not Dsn.Active;
  actDataModule.Enabled := not Dsn.Active;
  actNewForm.Enabled := not Dsn.Active;
  actRunMode.Enabled := Dsn.Active;
  actShowNewForm.Enabled := Assigned(NewForm);
end;

procedure TForm1.actShowReportExecute(Sender: TObject);
begin
  QuickReport1.PreView;
end;

procedure TForm1.actShowNewFormExecute(Sender: TObject);
begin
 if Assigned(NewForm) then
  NewForm.ShowModal;
end;

procedure TForm1.actRunModeExecute(Sender: TObject);
begin
 Dsn.Active := False;
end;

procedure TForm1.DsnValidateMethod(Sender: TObject; TypeData: PTypeData;
  ARoot: TObject; MethAddr: Pointer; const MethodName: String;
  var Accept: Boolean);
var m: TNotifyEvent;
begin
  Exit;
  Accept := True;
  if TypeData = GetTypeData(TypeInfo(TNotifyEvent)) then
   begin
    m := RunDesignerClick;         if @m = MethAddr then Exit;
    m := FormCreate;               if @m = MethAddr then Exit;
    m := DesignerEvents1ActiveDsnChanged;    if @m = MethAddr then Exit;
    m := DsnActiveChanged;         if @m = MethAddr then Exit;
    m := actShowReportExecute;     if @m = MethAddr then Exit;
    m := actShowNewFormExecute;    if @m = MethAddr then Exit;
    m := actRunModeExecute;        if @m = MethAddr then Exit;
    m := DataModule1.SomeEvent;    if @m = MethAddr then Exit;
   end;
  Accept := False;
end;

end.
